#pragma once

#include "ActorInterface.h"
#include "WASCommand.h"
#include "WASActor.h"

class CWASRefreshTicket : public CWASCommand
{
public:
	CWASRefreshTicket(CWASActor *pActor);
	~CWASRefreshTicket(void);

	void ExecuteAsync(void);
	void ExecuteReIssueTicketAsync(void);

private:
	bool ParseAndEventFire(nfc::CIkXMLDom * pDom);
	bool ReadandAssignTicket( nfc::CIkXMLDom * pDom );

protected:
	// override in drived class
	virtual void OnWasResponse(trid_t /*trid*/, bool /*bSuccess*/, int /*nWinINetErrorCode*/, int /*nHttpResponseCode*/, 
		LPCSTR /*szWasResCodeInHeader*/, 
		LPCSTR /*szWasResCodeInXml*/,
		nfc::CIkXMLDom * /*pDom*/);

	virtual void OnRequestTimeout(CHttpFacade * /*pHttpF*/, DWORD /*dwSeconds*/);

private:
	WSTRING m_strSession;
	bool	m_bReissueTicket;	//  '' Ƽ '߱'
};

class CWASCheckClientNetwork : public CWASCommand
{
public:
	CWASCheckClientNetwork(CWASActor *pActor);
	~CWASCheckClientNetwork(void);

	void ExecuteAsync(void);

private:
	bool ParseAndEventFire(nfc::CIkXMLDom * pDom);

protected:
	// override in drived class
	virtual void OnWasResponse(trid_t /*trid*/, bool /*bSuccess*/, int /*nWinINetErrorCode*/, int /*nHttpResponseCode*/, 
		LPCSTR /*szWasResCodeInHeader*/, 
		LPCSTR /*szWasResCodeInXml*/,
		nfc::CIkXMLDom * /*pDom*/);

	virtual void OnRequestTimeout(CHttpFacade * /*pHttpF*/, DWORD /*dwSeconds*/);

private:
	int		m_nCheckFailCnt;
};
